﻿//using AlienRace;
//using RimWorld;
//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Reflection;
//using Verse;
//using Verse.Sound;

//namespace ChangeRace
//{
//    public class ChangeRaceLogicDef_old : Def
//    {
//        public ChangeRace changeRace = new ChangeRace();
//        public List<factionOf> relationshipToPlayerFactionsResult = new List<factionOf>();
//        public BackstoryLogic backstoryLogic = new BackstoryLogic();
//        public bool testError = false;
//        public List<Trait> defaultForbiddenTraits = new List<Trait>();

//        public void ChangeRaceLogic(Pawn input, Hediff parentHediff)
//        {
//            bool playerSide = (input.IsPrisonerOfColony || input.IsFreeColonist || input.IsColonist || input.IsSlaveOfColony);
//            //오리지널 폰 요소 체크
//            TestErrorLog("!!!! Try check original pawn element !!!!");

//            //종족
//            TestPawnElement("def", input.def);

//            //동물훈련
//            TestPawnElement("trainability", input.RaceProps.trainability);

//            //지능
//            TestPawnElement("intelligence", input.RaceProps.intelligence);

//            //폰카인드
//            TestPawnElement("kindDef", input.kindDef);

//            //콜로니스트,죄수
//            TestErrorLog("Is Colonist Or Prisoner Or Slave : ");
//            CheckPawnIs(input, out string originalPawnIsString);
//            TestErrorLog(originalPawnIsString);

//            //factionOf 체크
//            TestErrorLog("relationshipToPlayerFactions : ");
//            CheckPawnRelationshipToPlayerFactions(input, out string originalPawnRelationshipToPlayerFactions);
//            TestErrorLog(originalPawnRelationshipToPlayerFactions.ToString());

//            //적대 여부
//            TestErrorLog("factionRelationKind : ");
//            CheckFactionRelationKind(input, out string originalPawnFactionRelationKind);
//            TestErrorLog(originalPawnFactionRelationKind);

//            //로얄 타이틀
//            TestPawnElement("royalTitle", input.royalty?.MostSeniorTitle?.def.defName);

//            //성별
//            TestPawnElement("gender", input.gender);

//            //팩션(Def)
//            TestPawnElement("factionDef", input.Faction?.def);

//            //조건 체크 시작
//            TestErrorLog("@@@@ Try check condition @@@@");
//            List<ConditionAndResult> conditionAndResult = changeRace.conditionAndResult;
//            for (int i = 0; i <= conditionAndResult.Count; i++)
//            {
//                //모든게 다 끝나고 나서도 변환에 실패할 경우
//                if (i == conditionAndResult.Count)
//                {
//                    TestErrorLog("@@@@ No more another conditionAndResult list, finish change race logic @@@@");
//                    return;
//                }
//                TestErrorLog($"ConditionAndResult list num : {i}");
//                List<Condition> condition = conditionAndResult[i].condition;
//                TestErrorLog($"Condition list count {condition.Count}");

//                //조건 체크, 만약 조건리스트중 하나의 조건이라도 만족하면 다음 조건을 체크함
//                TryCheckConditionList(condition, input, out int meetConditionNum);

//                TestErrorLog($"meetConditionNum{meetConditionNum}");

//                //만약에 조건 횟수 만족시
//                if (meetConditionNum == condition.Count)
//                {
//                    //종족 변환 
//                    TestErrorLog("#### Try start change race ####");

//                    Random rand = new Random();
//                    List<ChangeRaceResult> changeRaceResult = conditionAndResult[i].changeRaceResult;
//                    for (int j = 0; j <= changeRaceResult.Count; j++)
//                    {
//                        if (j == changeRaceResult.Count)
//                        {
//                            TestErrorLog("$$$$ There are no more possible lists to try. Try next ConditionAndResult list");
//                            break;
//                        }
//                        else
//                        {
//                            TestErrorLog($"Try change to : {changeRaceResult[j].thingDef.defName}", $"List Num : {j}");

//                            //먼저 확률부터 계산
//                            int randNum = rand.Next(1, 101);
//                            if (randNum <= changeRaceResult[j].chance)
//                            {
//                                TestErrorLog($"$$$$ The Chance : {changeRaceResult[j].chance} is higher than random number : {randNum}, so try start change race $$$$");

//                                //주변에 피 뿌리기
//                                if (changeRaceResult[j].makeFilth.filthDef != null)
//                                {
//                                    TestErrorLog("FilthDef : ", changeRaceResult[j].makeFilth.filthDef.defName);
//                                    CreateFilth(input, changeRaceResult[j].makeFilth.filthDef, changeRaceResult[j].makeFilth.filthNum);
//                                }

//                                //소리
//                                if (changeRaceResult[j].soundDef != null)
//                                {
//                                    SoundStarter.PlayOneShot(changeRaceResult[j].soundDef, SoundInfo.InMap(input, 0));
//                                }

//                                //아군의 장비 떨굼
//                                if (input.Faction == Faction.OfPlayer || input.Faction == Faction.OfPlayerSilentFail || changeRaceResult[j].unOfColonyPawnOrAnimalDropItem)
//                                {
//                                    TestErrorLog("Drop Item");
//                                    //동물 및 폰 아이템 떨구기
//                                    input.DropAndForbidEverything();
//                                    //아군 폰 계열이거나, 플래그가 true 이고, 다른세력일 경우
//                                    if ((playerSide || changeRaceResult[j].unOfColonyPawnOrAnimalDropItem) && input.RaceProps.intelligence == Intelligence.Humanlike)
//                                    {
//                                        TestErrorLog("Drop apparel and equipment");
//                                        input.apparel.DropAll(input.Position, true, true);
//                                        input.equipment.DropAllEquipment(input.Position, true);
//                                    }
//                                }

//                                //만약 thingDef가 아이템 계열일경우
//                                if (changeRaceResult[j].thingDef.category == ThingCategory.Item)
//                                {
//                                    TestErrorLog($"$$$${changeRaceResult[j].thingDef.defName} is Item category $$$$");
//                                    Thing thing = ThingMaker.MakeThing(changeRaceResult[j].thingDef, null);
//                                    thing.stackCount = changeRaceResult[j].stack;
//                                    GenPlace.TryPlaceThing(thing, input.Position, input.Map, 0, null, null, default);
//                                    input.Destroy(DestroyMode.Vanish);
//                                    TestErrorLog("$$$$ Finish Change $$$$");
//                                    SendMessage(input, thing, parentHediff, changeRaceResult[j]);
//                                }

//                                else
//                                {
//                                    TestErrorLog("$$$$ Create Replaced Pawn $$$$");

//                                    CreateReplacedPawn(
//                                        originalPawn: input,
//                                        factionOf: originalPawnRelationshipToPlayerFactions,
//                                        j: j,
//                                        changeRaceResultList: changeRaceResult,
//                                        relationshipToPlayerFactionsList: relationshipToPlayerFactionsResult,
//                                        parentHediff: parentHediff,
//                                        generatedPawn: out Pawn generatedPawn
//                                        );

//                                    if (generatedPawn == null)
//                                    {
//                                        //야생 폰인데, 우회용 폰카인드등이 없을경우 종료
//                                        return;
//                                    }

//                                    TestErrorLog("Try spawn to original pawn position");

//                                    GenSpawn.Spawn(generatedPawn, input.Position, input.Map, 0);

//                                    TestErrorLog("generatedPawn.def : " + generatedPawn.def.defName);

//                                    TestErrorLog("$$$$ Finish Spawn $$$$");

//                                    input.Destroy(DestroyMode.Vanish);
//                                }

//                                //종족변환 끝
//                                return;
//                            }
//                            else
//                            {
//                                TestErrorLog($"$$$$ The Chance : {changeRaceResult[j].chance} is lower than random number : {randNum}, so try the next list $$$$");
//                            }
//                        }
//                    }
//                }
//                else
//                {
//                    TestErrorLog("@@@@ Try test another conditionAndResult list @@@@");
//                }
//            }

//        }

//        private void CheckFactionRelationKind(Pawn pawn, out string pawnFactionRelationKind)
//        {
//            if (pawn.Faction == null)
//            {
//                pawnFactionRelationKind = "null";
//            }
//            else if (pawn.Faction != Faction.OfPlayer)
//            {
//                pawnFactionRelationKind = pawn.Faction.RelationWith(Faction.OfPlayer).ToString();
//            }
//            else
//            {
//                pawnFactionRelationKind = "Neutral";
//            }
//        }

//        private static void CheckPawnRelationshipToPlayerFactions(Pawn pawn, out string PawnRelationshipToPlayerFactions)
//        {
//            PawnRelationshipToPlayerFactions = "OfUnkwon";
//            if (pawn.Faction == Faction.OfPlayer)
//            {
//                PawnRelationshipToPlayerFactions = "OfPlayer";
//            }
//            else if (pawn.Faction == Faction.OfAncientsHostile)
//            {
//                PawnRelationshipToPlayerFactions = "OfAncientsHostile";
//            }
//            else if (pawn.Faction == Faction.OfAncients)
//            {
//                PawnRelationshipToPlayerFactions = "OfAncients";
//            }
//            else if (pawn.Faction == Faction.OfInsects)
//            {
//                PawnRelationshipToPlayerFactions = "OfInsects";
//            }
//            else if (pawn.Faction == Faction.OfMechanoids)
//            {
//                PawnRelationshipToPlayerFactions = "OfMechanoids";
//            }
//            else if (pawn.Faction == Faction.OfEmpire)
//            {
//                PawnRelationshipToPlayerFactions = "OfEmpire";
//            }
//            else if (pawn.Faction == Faction.OfPlayerSilentFail)
//            {
//                PawnRelationshipToPlayerFactions = "OfPlayerSilentFail";
//            }
//        }

//        private void SendMessage(Pawn originalPawn, Thing generatedThing, Hediff parentHediff, ChangeRaceResult changeRaceResult)
//        {
//            var generatedThingLabel = generatedThing.def.label;
//            if (generatedThing.def is ThingDef_AlienRace alienGeneratedThing)
//            {
//                generatedThingLabel = alienGeneratedThing.label;
//            }
//            if (changeRaceResult.sendMessageOrLetter.message != null)
//            {
//                Messages.Message(
//                    changeRaceResult.sendMessageOrLetter.message.Translate(originalPawn.LabelShort, generatedThingLabel, parentHediff.def.defName.CapitalizeFirst()).CapitalizeFirst(),
//                    generatedThing, changeRaceResult.sendMessageOrLetter.messageTypeDef ?? MessageTypeDefOf.NegativeHealthEvent,
//                    true);
//            }
//            if (changeRaceResult.sendMessageOrLetter.letterLabel != null && changeRaceResult.sendMessageOrLetter.letterText != null)
//            {
//                Find.LetterStack.ReceiveLetter(
//                    changeRaceResult.sendMessageOrLetter.letterLabel.Translate(originalPawn.LabelShort, generatedThingLabel, parentHediff.def.defName.CapitalizeFirst()).CapitalizeFirst(),
//                    changeRaceResult.sendMessageOrLetter.letterText.Translate(originalPawn.LabelShort, generatedThingLabel, parentHediff.def.defName.CapitalizeFirst()).CapitalizeFirst(),
//                    changeRaceResult.sendMessageOrLetter.letterDef ?? LetterDefOf.NegativeEvent,
//                    generatedThing,
//                    null, null, null, null); ;
//            }
//        }

//        private void TryCheckConditionList(List<Condition> conditionList, Pawn input, out int meetConditionNum)
//        {
//            meetConditionNum = 0;
//            for (int j = 0; j < conditionList.Count; j++)
//            {
//                bool tryCheckCondition = true;
//                //종족
//                CheckCondition(
//                    inputCompare: input.def,
//                    conditonCompareList: conditionList[j].thingDef,
//                    conditionName: "race",

//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //동물훈련
//                CheckCondition(
//                    inputCompare: input.RaceProps.trainability,
//                    conditonCompareList: conditionList[j].trainabilityDef,
//                    conditionName: "trainability",

//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //지능
//                CheckCondition(
//                    inputCompare: input.RaceProps.intelligence,
//                    conditonCompareList: conditionList[j].intelligence,
//                    conditionName: "intelligence",
//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //폰카인드
//                CheckCondition(
//                    inputCompare: input.kindDef,
//                    conditonCompareList: conditionList[j].pawnKindDef,
//                    conditionName: "pawnKindDef",
//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //콜로니스트,죄수 체크
//                CheckPawnIs(input, out string inputIs);
//                CheckCondition(
//                    inputCompare: inputIs,
//                    conditonCompareList: conditionList[j].pawnIs,
//                    conditionName: "pawnIs",
//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //적대 혹은 플레이어블 체크
//                CheckfactionOf(conditionList[j].factionOf, input, out string inputFactionOf);
//                CheckCondition(
//                   inputCompare: inputFactionOf,
//                   conditonCompareList: conditionList[j].factionOf,
//                   conditionName: "factionOf",
//                   tryCheckCondition: ref tryCheckCondition,
//                   meetConditionNum: ref meetConditionNum,
//                   conditionListNum: j);


//                //적대 체크
//                //TestErrorLog("@ factionRelationKind @");
//                if (input.Faction != Faction.OfPlayer && input.Faction != null)
//                {
//                    CheckCondition(
//                        inputCompare: input.Faction.RelationWith(Faction.OfPlayer).kind,
//                        conditonCompareList: conditionList[j].factionRelationKind,
//                        conditionName: "factionRelationKind",

//                        tryCheckCondition: ref tryCheckCondition,
//                        meetConditionNum: ref meetConditionNum,
//                        conditionListNum: j);
//                }


//                //로얄 타이틀 체크
//                //TestErrorLog("@ royalTitleDef @");
//                CheckCondition(
//                    inputCompare: input.royalty?.MostSeniorTitle?.def,
//                    conditonCompareList: conditionList[j].royalTitleDef,
//                    conditionName: "royalTitleDef",

//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //성별 체크
//                CheckCondition(
//                    inputCompare: input.gender,
//                    conditonCompareList: conditionList[j].gender,
//                    conditionName: "gender",
//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);

//                //팩션 체크
//                CheckCondition(
//                    inputCompare: input.Faction?.def,
//                    conditonCompareList: conditionList[j].factionDef,
//                    conditionName: "factionDef",

//                    tryCheckCondition: ref tryCheckCondition,
//                    meetConditionNum: ref meetConditionNum,
//                    conditionListNum: j);
//            }
//        }

//        private void CheckfactionOf(List<string> factionOfList, Pawn input, out string factionOf)
//        {
//            factionOf = "OfNullFaction";
//            if (input.Faction == null)
//            {
//                return;
//            }
//            for (int k = 0; k < factionOfList.Count; k++)
//            {
//                object FactionOf = null;
//                try
//                {
//                    FactionOf = typeof(Faction).GetProperty(factionOfList[k], BindingFlags.Public | BindingFlags.Static).GetValue(null);
//                }
//                catch { }
//                if (input.Faction == FactionOf)
//                {
//                    factionOf = factionOfList[k];
//                }
//            }
//        }

//        private void CheckCondition<T>(T inputCompare, List<T> conditonCompareList, string conditionName, int conditionListNum, ref int meetConditionNum, ref bool tryCheckCondition)
//        {
//            //TestErrorLog("@" + conditionName + "@");
//            if (tryCheckCondition && inputCompare != null)
//            {
//                for (int i = 0; i < conditonCompareList.Count; i++)
//                {
//                    T conditonCompare = conditonCompareList[i];
//                    if (inputCompare.Equals(conditonCompare))
//                    {
//                        meetConditionNum++;
//                        tryCheckCondition = false;
//                        TestErrorLog($"Condition list num : {conditionListNum}'s {conditionName} is match");
//                        TestErrorLog($"Pawn {conditionName} : {inputCompare}");
//                        break;
//                    }
//                }
//            }
//        }

//        private void TestPawnElement<T>(string pawnElementName, T pawnElement)
//        {
//            TestErrorLog($"pawn {pawnElementName} : ");

//            TestErrorLog(pawnElement?.ToString() ?? "null");
//            return;
//        }

//        //실질적 종족 변환 메소드
//        private void CreateReplacedPawn(in Pawn originalPawn, string factionOf, int j, List<ChangeRaceResult> changeRaceResultList, List<factionOf> relationshipToPlayerFactionsList, Hediff parentHediff, out Pawn generatedPawn)
//        {

//            Gender? generatedPawnGender = null;
//            Random randGender1 = new Random();
//            int randGenderNum1 = randGender1.Next(1, 101);
//            Random randGender2 = new Random();
//            int randGenderNum2 = randGender2.Next(1, 101);
//            bool isWildMan = false;

//            //성별 설정
//            {
//                if (!changeRaceResultList[j].thingDef.race.hasGenders)
//                {
//                    TestErrorLog($"{changeRaceResultList[j].thingDef.race}'s gender is none");
//                }
//                else if (changeRaceResultList[j].keepWhat.keepGender)
//                {
//                    TestErrorLog($"keepGender is true : generatedPawnGender = {originalPawn.gender}");
//                    generatedPawnGender = originalPawn.gender;
//                }
//                else if (randGenderNum1 <= changeRaceResultList[j].genderResult.Female)
//                {
//                    generatedPawnGender = Gender.Female;
//                    TestErrorLog($"keepGender is false : Try draw generatedPawnGender = {generatedPawnGender}");
//                }
//                else if (randGenderNum2 <= changeRaceResultList[j].genderResult.Male)
//                {
//                    generatedPawnGender = Gender.Male;
//                    TestErrorLog($"keepGender is false : Try draw generatedPawnGender = {generatedPawnGender}");
//                }
//            }

//            //팩션 폰카인드 설정
//            TestErrorLog("Try set pawnKind and faction");
//            var kindDef = changeRaceResultList[j].pawnKindDef;
//            Faction factionSet = null;

//            if (kindDef == PawnKindDefOf.WildMan)
//            {
//                TestErrorLog("Set to Wild (pawnkind)");
//                if (changeRaceResultList[j].thingDef.race.Humanlike)
//                {
//                    if (changeRaceResultList[j].temporaryPawnKindDefForWildMan == null)
//                    {
//                        TestErrorLog("You tried set pawn kind = wildman, but temporaryPawnKindDefForWildMan is empty. End change race logic.");
//                        generatedPawn = null;
//                        return;
//                    }
//                    kindDef = changeRaceResultList[j].temporaryPawnKindDefForWildMan;
//                    isWildMan = true;
//                }
//            }
//            else if (changeRaceResultList[j].makeOfPlayer)
//            {
//                TestErrorLog("Set to OfPlayer (makeOfPlayer)");
//                factionSet = Faction.OfPlayer;
//            }
//            else if (changeRaceResultList[j].keepWhat.keepFaction)
//            {
//                TestErrorLog("Keep original pawn faction (keepFaction)");
//                factionSet = originalPawn.Faction;
//            }
//            else
//            {
//                for (int a = 0; a < relationshipToPlayerFactionsList.Count; a++)
//                {
//                    //조건 체크, 만약 조건리스트중 하나의 조건이라도 만족하면 다음 조건을 체크함
//                    TryCheckConditionList(relationshipToPlayerFactionsList[a].condition, originalPawn, out int meetRelationshipConditionNum);

//                    TestErrorLog($"meetRelationshipConditionNum : {meetRelationshipConditionNum}");

//                    TestErrorLog($"condition list count : {changeRace.conditionAndResult[a].condition.Count}");

//                    if (meetRelationshipConditionNum == relationshipToPlayerFactionsList[a].condition.Count)
//                    {

//                        if (relationshipToPlayerFactionsList[a].factionResult.keepOriginalFaction)
//                        {
//                            TestErrorLog("Keep original pawn faction (condition)");
//                            factionSet = originalPawn.Faction;
//                            break;
//                        }
//                        else if (relationshipToPlayerFactionsList[a].factionResult.isPlayerFaction)
//                        {
//                            TestErrorLog("Set to OfPlayer (condition)");
//                            factionSet = Faction.OfPlayer;
//                            break;
//                        }
//                        else if (relationshipToPlayerFactionsList[a].factionResult.isWildMan)
//                        {
//                            TestErrorLog("Set to Wild (condition)");
//                            factionSet = null;
//                            if (changeRaceResultList[j].thingDef.race.Humanlike)
//                            {
//                                if (changeRaceResultList[j].temporaryPawnKindDefForWildMan == null)
//                                {
//                                    TestErrorLog("You tried set pawn kind = wildman, but temporaryPawnKindDefForWildMan is empty. End change race logic.");
//                                    generatedPawn = null;
//                                    return;
//                                }
//                                kindDef = changeRaceResultList[j].temporaryPawnKindDefForWildMan;
//                                isWildMan = true;
//                            }
//                            break;
//                        }
//                    }
//                    else if (a == changeRace.conditionAndResult.Count - 1)
//                    {
//                        TestErrorLog("All of FactionResult are false : try set faction use factionOf");
//                        if (factionOf != "OfUnkwon")
//                        {
//                            factionSet = (Faction)typeof(Faction).GetProperty(factionOf, BindingFlags.Public | BindingFlags.Static).GetValue(null);
//                            break;
//                        }
//                        else
//                        {
//                            TestErrorLog("Fail use factionOf (condition unmatch), Set to Null Faction");
//                            factionSet = null;
//                            break;
//                        }

//                    }
//                }
//            }
//            if (!isWildMan)
//            {
//                TestErrorLog("generatedPawn pawnKindDef : ", kindDef.defName);
//            }
//            else
//            {
//                TestErrorLog("temporaryPawnKindDefForWildMan : ", kindDef.defName);
//                TestErrorLog("generatedPawn pawnKindDef : ", PawnKindDefOf.WildMan.defName);
//            }

//            PawnGenerationRequest generationRequest = new PawnGenerationRequest(
//            kind: kindDef,
//            faction: factionSet,
//            fixedBiologicalAge: 1,
//            fixedChronologicalAge: 1,
//            fixedGender: generatedPawnGender);


//            TestErrorLog("Try generate Pawn : ");
//            TestErrorLog($"PawnKindDef : {changeRaceResultList[j].pawnKindDef.defName}");
//            TestErrorLog($"AgeBiologicalYearsFloat : {originalPawn.ageTracker.AgeBiologicalYearsFloat}");
//            TestErrorLog($"Gender : {generatedPawnGender}");

//            TestErrorLog("generate pawn and create");
//            // generate pawn and create 

//            generatedPawn = PawnGenerator.GeneratePawn(generationRequest);

//            generatedPawn.ageTracker.AgeBiologicalTicks = originalPawn.ageTracker.AgeBiologicalTicks;
//            generatedPawn.ageTracker.AgeChronologicalTicks = originalPawn.ageTracker.AgeChronologicalTicks;

//            //헤디프 추가

//            TestErrorLog("generate pawn add hediff : ");
//            for (int k = 0; k < changeRaceResultList[j].addHediffDef.Count; k++)
//            {
//                generatedPawn.health.AddHediff(changeRaceResultList[j].addHediffDef[k]);

//                TestErrorLog(changeRaceResultList[j].addHediffDef[k].defName);
//            }

//            if (isWildMan)
//            {
//                generatedPawn.kindDef = PawnKindDefOf.WildMan;
//            }

//            if (changeRaceResultList[j].thingDef is ThingDef_AlienRace alienThing && alienThing.alienRace.generalSettings.maleGenderProbability < 0.001)
//            {
//                Log.Error($"Because {alienThing.defName}'s maleGenderProbability is low then 0.001, so copy names may fail.");
//            }
//            TestErrorLog("Copy pawn name");
//            CopyName(originalPawn, generatedPawn);
//            TestErrorLog(generatedPawn.Name.ToString());

//            TestErrorLog("Relation Setting");
//            // 관계가 이어짐 (20201112 확인)
//            if (changeRaceResultList[j].keepWhat.keepReration)
//            {
//                TranslatePawnRelations(originalPawn, generatedPawn, changeRaceResultList[j].bondChangeToLover);
//                TestErrorLog("Keep reration");
//            }
//            if (originalPawn.RaceProps.Humanlike && changeRaceResultList[j].keepWhat.keepThought_MemorySocial)
//            {
//                TranslatePawnThought_MemorySocial(originalPawn, generatedPawn);
//                TestErrorLog("Keep Thought_MemorySocia");
//            }
//            else { TestErrorLog("Delete reration"); }

//            if (generatedPawn.RaceProps.Humanlike)
//            {
//                //이하 인간 계열
//                //백스 설정
//                (var childhood, var adult) = GetBackstory(originalPawn, generatedPawn, backstoryLogic);
//                generatedPawn.story.childhood = childhood;
//                generatedPawn.story.adulthood = adult;

//                //외형
//                TestErrorLog("Set appearance");
//                Random rand = new Random();
//                Random rand2 = new Random();
//                List<Appearance> appearance = changeRaceResultList[j].appearance;
//                for (int k = 0; k < appearance.Count; k++)
//                {
//                    //먼저 확률부터 계산
//                    int randNum = rand.Next(1, 101);
//                    if (randNum <= appearance[k].chance)
//                    {
//                        TestErrorLog($"Try use appearance list : {k}");
//                        if (!appearance[k].head.NullOrEmpty())
//                        {
//                            generatedPawn.GetComp<AlienPartGenerator.AlienComp>().crownType = appearance[k].head;
//                            TestErrorLog($"Head : ", appearance[k].head);
//                        }
//                        if (appearance[k].hairDef != null)
//                        {
//                            generatedPawn.story.hairDef = appearance[k].hairDef;
//                            TestErrorLog("HairDef : ", appearance[k].hairDef.defName);
//                        }
//                        if (appearance[k].bodyTypeDef != null)
//                        {
//                            generatedPawn.story.bodyType = appearance[k].bodyTypeDef;
//                            TestErrorLog("BodyTypeDef : ", appearance[k].bodyTypeDef.defName);
//                        }

//                        //헤어색
//                        TestErrorLog("Hair color : ");
//                        if (changeRaceResultList[j].keepWhat.keepHairColor && originalPawn.story.hairColor != null)
//                        {
//                            TestErrorLog("keep original pawn hair color");
//                            generatedPawn.story.hairColor = originalPawn.story.hairColor;

//                            //TestErrorLog("fail to keep original pawn hair color, It could be because the original pawn is not humanlike or does not have a Hair def.");
//                        }
//                        else if (!appearance[k].hairColor.NullOrEmpty())
//                        {
//                            int randNum2 = rand2.Next(0, appearance[k].hairColor.Count);
//                            generatedPawn.story.hairColor = appearance[k].hairColor[randNum2];
//                            TestErrorLog(randNum2.ToString(), generatedPawn.story.hairColor.ToString());
//                        }
//                        break;
//                    }
//                }

//                //스킬 복사
//                TestErrorLog("Copy or make skills");
//                generatedPawn.skills = originalPawn.skills ?? generatedPawn.skills; // move skills

//                //트레잇 설정
//                TestErrorLog("Set trait");
//                //지금 여기 문제, 아마 null 처리가 제대로 안되는듯
//                if (originalPawn.RaceProps.Humanlike)
//                {
//                    generatedPawn.story.traits.allTraits = originalPawn.story.traits.allTraits ?? generatedPawn.story.traits.allTraits; // move traits
//                }
//                TestErrorLog("Remove forbidden trait");
//                var forbiddenTraitsList = changeRaceResultList[j].forbiddenTraits;
//                if (changeRaceResultList[j].useDefaultForbiddenTraits)
//                {
//                    forbiddenTraitsList = defaultForbiddenTraits;
//                }
//                RemoveForbiddenTrait(ref generatedPawn, forbiddenTraitsList);
//            }
//            SendMessage(originalPawn, generatedPawn, parentHediff, changeRaceResultList[j]);
//        }

//        private void TranslatePawnThought_MemorySocial(Pawn from, Pawn to)
//        {
//            var thought_MemorySocial_Mood_DefName = "AAA123";
//            for (int i = 0; i < from.needs.mood.thoughts.memories.Memories.Count; i++)
//            {
//                var thought_MemorySocial = from.needs.mood.thoughts.memories.Memories[i];
//                if (thought_MemorySocial is Thought_MemorySocial || thought_MemorySocial.def.defName.Contains(thought_MemorySocial_Mood_DefName))
//                {
//                    to.needs.mood.thoughts.memories.Memories.Add(thought_MemorySocial);
//                    thought_MemorySocial_Mood_DefName = thought_MemorySocial.def.defName;
//                }
//            }
//        }

//        private void TranslatePawnRelations(Pawn from, Pawn to, bool bondChangeToLover)
//        {
//            for (int i = 0; i < from.relations.DirectRelations.Count; i++)
//            {
//                DirectPawnRelation relation = from.relations.DirectRelations[i];
//                if (relation.def == PawnRelationDefOf.Bond && bondChangeToLover)
//                {
//                    relation.def = PawnRelationDefOf.Lover;
//                }
//                else
//                {
//                    RemoveRelationFromOtherRelatedPawns(from);
//                }
//                to.relations.AddDirectRelation(relation.def, relation.otherPawn);
//            }

//            RemoveRelationFromOtherRelatedPawns(from);
//        }
//        private void CopyName(Pawn from, Pawn to)
//        {
//            var name = from.Name;
//            if (name is NameTriple triple)
//                to.Name = new NameTriple(triple.First, triple.Nick, triple.Last);
//            else if (name is NameSingle single)
//                to.Name = new NameSingle(single.Name, single.Numerical);
//            else
//                to.Name = name;
//        }
//        private void RemoveRelationFromOtherRelatedPawns(Pawn pawn)
//        { // pawn과 관계가 있는 모든 폰에게서 pawn에 관한 관계를 삭제
//            var relatedPawns = pawn.relations.RelatedPawns;
//            foreach (var otherPawn in relatedPawns)
//            {
//                var relationsList = new List<DirectPawnRelation>(otherPawn.relations.DirectRelations);
//                foreach (var relation in relationsList.Where(r => r.otherPawn == pawn))
//                    otherPawn.relations.RemoveDirectRelation(relation);
//            }
//        }
//        private void RemoveForbiddenTrait(ref Pawn pawn, List<Trait> forbiddenTraits)
//        {
//            var pawnTraits = pawn.story.traits.allTraits;

//            for (int i = 0; i < forbiddenTraits.Count; i++)
//            {
//                Trait forbiddenTrait = forbiddenTraits[i];
//                for (int j = 0; j < pawnTraits.Count; j++)
//                {
//                    if (pawnTraits[j].def == forbiddenTrait.def && pawnTraits[j].Degree == forbiddenTrait.Degree)
//                    {
//                        TestErrorLog("=================");
//                        TestErrorLog(pawnTraits[j].def.defName);
//                        TestErrorLog(pawnTraits[j].Degree.ToString());

//                        pawnTraits.Remove(pawnTraits[j]);
//                    }
//                }
//            }
//            TestErrorLog("=================");
//        }

//        // 오리지널 폰의 팩션에 따른 따른 민초 백스토리와 팩션, pawnkind 설정
//        private (Backstory childhood, Backstory adult) GetBackstory(Pawn originalPawn, Pawn generatedPawn, BackstoryLogic backstoryLogic)
//        {
//            Backstory childHoodBackstory = null;
//            Backstory adultHoodBackstory = null;
//            bool useOriginalBackstory = false;
//            string childHoodBackstoryString = "";
//            List<string> childHoodBackstoryStringList = new List<string>();

//            //백스 설정
//            if (!backstoryLogic.keepOriginalPawnBackstory)
//            {
//                //현재 종족, 접두사
//                CustomElementName customElementName = backstoryLogic.customElementName;
//                List<PrefixElement> prefixElement = customElementName.prefixElement;
//                DefaultElementName defaultElementName = backstoryLogic.defaultElementName;
//                for (int i = 0; i < prefixElement.Count; i++)
//                {
//                    OutElementName(
//                              prefixElement[i].resultRace,
//                              prefixElement[i],
//                              generatedPawn.def,
//                              ref defaultElementName.prefix,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("prefix : ", defaultElementName.prefix);

//                //이전 종족
//                List<RaceElement> raceElement = customElementName.raceElement;
//                for (int i = 0; i < raceElement.Count; i++)
//                {
//                    OutElementName(
//                              raceElement[i].originalRace,
//                              raceElement[i],
//                              originalPawn.def,
//                              ref defaultElementName.race,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("race : ", defaultElementName.race);

//                //이전 관계
//                List<factionOf_BeforeElement> factionOf_BeforeElement = customElementName.factionOf_BeforeElement;
//                for (int i = 0; i < factionOf_BeforeElement.Count; i++)
//                {
//                    CheckfactionOf(factionOf_BeforeElement[i].factionOf_Before, originalPawn, out string originalfactionOf);
//                    OutElementName(
//                              factionOf_BeforeElement[i].factionOf_Before,
//                              factionOf_BeforeElement[i],
//                              originalfactionOf,
//                              ref defaultElementName.factionOf_Before,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("factionOf_Before : ", defaultElementName.factionOf_Before);

//                //현재 관계
//                List<factionOf_AfterElement> factionOf_AfterElement = customElementName.factionOf_AfterElement;
//                for (int i = 0; i < factionOf_AfterElement.Count; i++)
//                {
//                    CheckfactionOf(factionOf_AfterElement[i].factionOf_After, originalPawn, out string originalfactionOf);
//                    OutElementName(
//                              factionOf_AfterElement[i].factionOf_After,
//                              factionOf_AfterElement[i],
//                              originalfactionOf,
//                              ref defaultElementName.factionOf_After,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("factionOf_After : ", defaultElementName.factionOf_After);

//                //로얄 타이틀
//                List<RoyalTitleElement> royalTitleElement = customElementName.royalTitleElement;
//                for (int i = 0; i < royalTitleElement.Count; i++)
//                {
//                    OutElementName(
//                              royalTitleElement[i].royalTitleDef,
//                              royalTitleElement[i],
//                              originalPawn.royalty?.MostSeniorTitle?.def,
//                              ref defaultElementName.royalTitle,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("royalTitle : ", defaultElementName.royalTitle);

//                //팩션Def
//                List<FactionElement> factionElement = customElementName.factionElement;
//                for (int i = 0; i < factionElement.Count; i++)
//                {
//                    OutElementName(
//                              factionElement[i].originalFactionDef,
//                              factionElement[i],
//                              originalPawn.Faction?.def,
//                              ref defaultElementName.faction,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("faction : ", defaultElementName.faction);

//                //동물훈련
//                List<TrainabilityElement> trainabilityElement = customElementName.trainabilityElement;
//                for (int i = 0; i < trainabilityElement.Count; i++)
//                {
//                    OutElementName(
//                              trainabilityElement[i].trainabilityDef,
//                              trainabilityElement[i],
//                              originalPawn.RaceProps.trainability,
//                              ref defaultElementName.trainability,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("trainability : ", defaultElementName.trainability);

//                //지능
//                List<IntelligenceElement> intelligenceElement = customElementName.intelligenceElement;
//                for (int i = 0; i < intelligenceElement.Count; i++)
//                {
//                    OutElementName(
//                              intelligenceElement[i].intelligence,
//                              intelligenceElement[i],
//                              originalPawn.RaceProps.intelligence,
//                              ref defaultElementName.intelligence,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("intelligence : ", defaultElementName.intelligence);

//                //이전 성별
//                List<Gender_BeforeElement> gender_BeforeElement = customElementName.gender_BeforeElement;
//                for (int i = 0; i < gender_BeforeElement.Count; i++)
//                {
//                    OutElementName(
//                              gender_BeforeElement[i].gender_Before,
//                              gender_BeforeElement[i],
//                              originalPawn.gender,
//                              ref defaultElementName.gender_Before,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("gender_Before : ", defaultElementName.gender_Before);

//                //현재 성별
//                List<Gender_AfterElement> gender_AfterElement = customElementName.gender_AfterElement;
//                for (int i = 0; i < gender_AfterElement.Count; i++)
//                {
//                    OutElementName(
//                              gender_AfterElement[i].gender_After,
//                              gender_AfterElement[i],
//                              generatedPawn.gender,
//                              ref defaultElementName.gender_After,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("gender_After : ", defaultElementName.gender_After);

//                //나이
//                List<AgeElement> ageElement = customElementName.ageElement;
//                for (int i = 0; i < customElementName.ageElement.Count; i++)
//                {
//                    for (int j = 0; j < ageElement[i].age.Count; j++)
//                    {
//                        if (ageElement[i].age[j].min <= originalPawn.ageTracker.AgeBiologicalYears && originalPawn.ageTracker.AgeBiologicalYears <= ageElement[i].age[j].max && !useOriginalBackstory)
//                        {
//                            if (ageElement[i].keepOriginalBackstory)
//                            {
//                                useOriginalBackstory = true;
//                            }
//                            else
//                            {
//                                defaultElementName.age = ageElement[i].elementName;
//                            }
//                            break;
//                        }
//                    }

//                }
//                TestErrorLog("age : ", defaultElementName.age);

//                //이전 폰카인드
//                List<PawnKind_BeforeElement> pawnKind_BeforeElement = customElementName.pawnKind_BeforeElement;
//                for (int i = 0; i < pawnKind_BeforeElement.Count; i++)
//                {
//                    OutElementName(
//                              pawnKind_BeforeElement[i].pawnKind_Before,
//                              pawnKind_BeforeElement[i],
//                              originalPawn.kindDef,
//                              ref defaultElementName.pawnKind_Before,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("pawnKind_Before : ", defaultElementName.pawnKind_Before);

//                //현재 폰카인드
//                List<PawnKind_AfterElement> pawnKind_AfterElement = customElementName.pawnKind_AfterElement;
//                for (int i = 0; i < pawnKind_AfterElement.Count; i++)
//                {
//                    OutElementName(
//                              pawnKind_AfterElement[i].pawnKind_After,
//                              pawnKind_AfterElement[i],
//                              generatedPawn.kindDef,
//                              ref defaultElementName.pawnKind_After,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("pawnKind_After : ", defaultElementName.pawnKind_After);

//                //팩션 FactionRelationKind 이전
//                var factionRelationKind_Before = FactionRelationKind.Neutral;
//                if (originalPawn.Faction != Faction.OfPlayer && originalPawn.Faction != null)
//                {
//                    factionRelationKind_Before = originalPawn.Faction.RelationWith(Faction.OfPlayer).kind;
//                }

//                List<FactionRelationKind_BeforeElement> factionRelationKind_BeforeElement = customElementName.factionRelationKind_BeforeElement;
//                for (int i = 0; i < factionRelationKind_BeforeElement.Count; i++)
//                {
//                    OutElementName(
//                              factionRelationKind_BeforeElement[i].factionRelationKind_Before,
//                              factionRelationKind_BeforeElement[i],
//                              factionRelationKind_Before,
//                              ref defaultElementName.factionRelationKind_Before,
//                              ref useOriginalBackstory);
//                }

//                TestErrorLog("factionRelationKind_Before : ", defaultElementName.factionRelationKind_Before);


//                //팩션 FactionRelationKind 이후
//                var factionRelationKind_After = FactionRelationKind.Neutral;
//                if (originalPawn.Faction != Faction.OfPlayer && originalPawn.Faction != null)
//                {
//                    factionRelationKind_After = generatedPawn.Faction.RelationWith(Faction.OfPlayer).kind;
//                }
//                List<FactionRelationKind_AfterElement> factionRelationKind_AfterElement = customElementName.factionRelationKind_AfterElement;
//                for (int i = 0; i < factionRelationKind_AfterElement.Count; i++)
//                {
//                    OutElementName(
//                              factionRelationKind_AfterElement[i].factionRelationKind_After,
//                              factionRelationKind_AfterElement[i],
//                              factionRelationKind_After,
//                              ref defaultElementName.factionRelationKind_After,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("factionRelationKind_After : ", defaultElementName.factionRelationKind_After);

//                //콜로니스트, 노예, 수감자 이전
//                List<PawnIs_BeforeElement> pawnIsElement_Befores = customElementName.pawnIs_BeforeElement;
//                CheckPawnIs(originalPawn, out string pawnIs_Before);
//                for (int i = 0; i < pawnIsElement_Befores.Count; i++)
//                {
//                    OutElementName(
//                              pawnIsElement_Befores[i].pawnIs_Before,
//                              pawnIsElement_Befores[i],
//                              pawnIs_Before,
//                              ref defaultElementName.pawnIs_Before,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("pawnIsElement_Befores : ", defaultElementName.pawnIs_Before);

//                //콜로니스트, 노예, 수감자 이후
//                List<PawnIs_AfterElement> pawnIsElement_Afters = customElementName.pawnIs_AfterElement;
//                CheckPawnIs(generatedPawn, out string pawnIs_After);
//                for (int i = 0; i < pawnIsElement_Afters.Count; i++)
//                {
//                    OutElementName(
//                              pawnIsElement_Afters[i].pawnIs_After,
//                              pawnIsElement_Afters[i],
//                              pawnIs_After,
//                              ref defaultElementName.pawnIs_After,
//                              ref useOriginalBackstory);
//                }
//                TestErrorLog("pawnIsElement_Afters : ", defaultElementName.pawnIs_After);

//                //마지막으로 스트링 합치기
//                for (int i = 0; i < backstoryLogic.backstoryElementSequence.Count; i++)
//                {
//                    try
//                    {
//                        Type tp = typeof(DefaultElementName);
//                        FieldInfo fld = tp.GetField(backstoryLogic.backstoryElementSequence[i], BindingFlags.Instance |
//                                               BindingFlags.NonPublic |
//                                               BindingFlags.Public |
//                                               BindingFlags.NonPublic);
//                        object point = fld.GetValue(defaultElementName);
//                        if ((string)point != "")
//                        {
//                            childHoodBackstoryString += (string)point;
//                            childHoodBackstoryStringList.Add(childHoodBackstoryString);
//                        }
//                    }
//                    catch
//                    {
//                        Log.Error(backstoryLogic.backstoryElementSequence[i] + " is null backstoryElement");
//                    }
//                }
//                TestErrorLog("Assembled childHoodBackstory string : ", childHoodBackstoryString);
//            }

//            TestErrorLog($"List count : {childHoodBackstoryStringList.Count}", childHoodBackstoryStringList[childHoodBackstoryStringList.Count - 1]);
//            TestErrorLog("childHoodBackstory : ");

//            if (!useOriginalBackstory)
//            {
//                bool tryDefaultBackstory = true;
//                for (int i = childHoodBackstoryStringList.Count - 1; 0 <= i; i--)
//                {
//                    if (BackstoryDatabase.allBackstories.ContainsKey(childHoodBackstoryStringList[i]))
//                    {
//                        childHoodBackstory = BackstoryDatabase.allBackstories[childHoodBackstoryStringList[i]];
//                        tryDefaultBackstory = false;
//                        TestErrorLog($"Success : ChildHoodBackstoryDef : {childHoodBackstoryStringList[i]}");
//                        break;
//                    }
//                    else
//                    {
//                        TestErrorLog($"{childHoodBackstoryStringList[i]} is null childHoodBackstoryDef. Try Next...");
//                    }
//                }
//                if (tryDefaultBackstory)
//                {
//                    TestErrorLog("All custom backstory setting is failed, Try set defaultBackstoryDef");
//                    childHoodBackstory = backstoryLogic.defaultBackstoryDef.backstory;
//                    adultHoodBackstory = null;
//                    TestErrorLog("childHoodBackstory : ", childHoodBackstory.ToString(), "adultHoodBackstory : ", "null");
//                }
//            }
//            else if (useOriginalBackstory || childHoodBackstory == null)
//            {
//                TestErrorLog("Keep original backstory");
//                childHoodBackstory = originalPawn.story.childhood ?? null;
//                adultHoodBackstory = originalPawn.story.adulthood ?? null;
//                TestErrorLog("childHoodBackstory : ", childHoodBackstory.ToString() ?? "null", "adultHoodBackstory : ", adultHoodBackstory.ToString() ?? "null");
//            }
//            return (childHoodBackstory, adultHoodBackstory);
//        }

//        private static void CheckPawnIs(Pawn pawn, out string pawnIs)
//        {
//            pawnIs = "IsNotColonistOrPrisonerOrSlave";
//            if (pawn.IsFreeColonist)
//            {
//                pawnIs = "IsFreeColonist";
//            }
//            else if (pawn.IsColonist)
//            {
//                pawnIs = "IsColonist";
//            }
//            else if (pawn.IsPrisonerOfColony)
//            {
//                pawnIs = "IsPrisonerOfColony";
//            }
//            else if (pawn.IsPrisoner)
//            {
//                pawnIs = "IsPrisoner";
//            }
//            else if (pawn.IsSlaveOfColony)
//            {
//                pawnIs = "IsSlaveOfColony";
//            }
//            else if (pawn.IsSlave)
//            {
//                pawnIs = "IsSlave";
//            }
//        }

//        private static void OutElementName<T>(List<T> elementNameList, BackstoryElement backstoryElement, T originalPawnCondition, ref string backstoryLogicDefaultElementName, ref bool useOriginalBackstory)
//        {
//            if (!useOriginalBackstory && originalPawnCondition != null)
//            {
//                for (int j = 0; j < elementNameList.Count; j++)
//                {
//                    if ((bool)(originalPawnCondition?.Equals(elementNameList[j])))
//                    {
//                        if (backstoryElement.keepOriginalBackstory)
//                        {
//                            useOriginalBackstory = true;
//                        }
//                        else
//                        {
//                            backstoryLogicDefaultElementName = backstoryElement.elementName;
//                        }
//                        break;
//                    }
//                    if (useOriginalBackstory)
//                        break;
//                }
//            }
//        }
//        //이하 종족 변환 아닌것
//        private void CreateFilth(Pawn input, ThingDef filthDef, int filthNum)
//        {
//            for (int i = 0; i < filthNum; i++)
//            {
//                IntVec3 Pos = input.Position + GenRadial.RadialPattern[i];
//                bool canPlaceFilthToPos = GenGrid.InBounds(Pos, input.Map) && GridsUtility.GetRoomOrAdjacent(input.Position, input.Map, (RegionType)6) == GridsUtility.GetRoomOrAdjacent(Pos, input.Map, (RegionType)6);
//                if (canPlaceFilthToPos)
//                    FilthMaker.TryMakeFilth(input.Position, input.Map, filthDef, GenText.LabelIndefinite(input), Rand.RangeInclusive(0, 4));
//            }
//        }
//        private void TestErrorLog(params string[] arr1)
//        {
//            if (testError)
//            {
//                for (int i = 0; i < arr1.Length; i++)
//                {
//                    Log.Error(arr1[i]);
//                }
//            }
//        }
//    }
//}