﻿using Mincho_The_Mint_Choco_Slime;
using RimWorld;
using Verse;

namespace MinchoWitch
{
    public class DeathActionWorker_DestroyCorpse_MinchoGolem : DeathActionWorker
    {
        public override bool DangerousInMelee
        {
            get
            {
                return false;
            }
        }
        // Token: 0x060044E6 RID: 17638 RVA: 0x001707C8 File Offset: 0x0016E9C8
        public override void PawnDied(Corpse corpse)
        {
            FilthMaker.TryMakeFilth(corpse.Position, corpse.Map, MinchoDefOf.Mincho_Filth_BloodDef, 5, FilthSourceFlags.None);
            Thing thing = ThingMaker.MakeThing(MinchoDefOf.Mincho_Mintchoco, null);
            thing.stackCount = 40;
            Thing thing2 = ThingMaker.MakeThing(ThingDefOf.Chocolate, null);
            thing.stackCount = 40;
            GenPlace.TryPlaceThing(thing, corpse.Position, corpse.Map, (ThingPlaceMode)0, null, null, default);
            GenPlace.TryPlaceThing(thing2, corpse.Position, corpse.Map, (ThingPlaceMode)0, null, null, default);
            corpse.InnerPawn.DropAndForbidEverything();
            corpse.Destroy(0);
        }
    }
}
