﻿using UnityEngine;
using Verse;

namespace ChangeRace
{
    [StaticConstructorOnStartup]
    public class ChangeRace_Setting : ModSettings
    {
        public override void ExposeData()
        {
            base.ExposeData();
            Scribe_Values.Look(ref ChangeRaceTestLog, "ChangeRaceTestLog", false);
        }
        public void DoSettingsWindowContents(Rect canvas)
        {
            Listing_Standard listing_Standard = new Listing_Standard
            {
                ColumnWidth = (canvas.width - 34f) / 2f
            };
            listing_Standard.Begin(canvas);

            //ChangeRaceDef 테스트 로그 활성화
            listing_Standard.CheckboxLabeled("ChangeRaceTestLog".Translate(), ref ChangeRaceTestLog, "ChangeRaceTestLogToolTip".Translate());
            listing_Standard.Gap(10f);
            listing_Standard.GapLine(10f);

            //끝
            listing_Standard.End();
        }

        public static bool ChangeRaceTestLog = false;
    }
}