﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text.RegularExpressions;
//using Mincho_The_Mint_Choco_Slime;
//using RimWorld;
//using Verse;
//using Verse.Sound;

//namespace MinchoWitch
//{
//    public static class MinchoGenerator
//    {
//        static MinchoGenerator()
//        {
//            var forbiddenTraits = @"Nudist,
//								TooSmart,
//								Transhumanist,
//								BodyPurist,
//								Masochist,
//								Pyromaniac,
//								Wimp,
//								FastLearner,
//								GreatMemory,
//								Psychopath,
//								Bloodlust,
//								SpeedOffset,
//								PsychicSensitivity,
//								Tough,
//								Nimble,
//								Abrasive,
//								DislikesMen,
//								DislikesWomen,
//								Beauty,
//								AnnoyingVoice,
//								CreepyBreathing,
//								DrugDesire,
//								Immunity";
//            var matches = Regex.Matches(forbiddenTraits, "[a-zA-Z]+");
//            forbiddenStrings = new HashSet<string>();
//            foreach (var match in matches)
//                forbiddenStrings.Add(((Match)match).Value);
//        }
//        public static HashSet<String> forbiddenStrings;

//        public static PawnKindDef pawnkind { get; private set; }

//        //최종적으로 민초로 바꾸는 부분
//        public static void ConvertToMincho(Pawn originalPawn, Hediff hediff)
//        {
//            //피를 먼저 뿌림
//            CreateMinchoFilth(originalPawn);
//            //만약 훈련시 지능이 똑똑함이 아닐때 = 대부분의 동물
//            if (originalPawn.RaceProps.trainability == TrainabilityDefOf.None || originalPawn.RaceProps.trainability == TrainabilityDefOf.Simple || originalPawn.RaceProps.trainability == TrainabilityDefOf.Intermediate)
//            {
//                Pawn generatedPawn = null;
//                if (originalPawn.RaceProps.trainability == TrainabilityDefOf.None || originalPawn.RaceProps.trainability == TrainabilityDefOf.Simple)
//                {
//                    //민초에옹소환
//                    generatedPawn = PawnGenerator.GeneratePawn(MinchoWitchDefOf.Mincho_Minchonyang, originalPawn.Faction);
//                }
//                else if (originalPawn.RaceProps.trainability == TrainabilityDefOf.Intermediate)
//                {
//                    //민뭉소환
//                    generatedPawn = PawnGenerator.GeneratePawn(MinchoWitchDefOf.Mincho_Minmoong, originalPawn.Faction);
//                }
//                //이름 복사
//                CopyName(originalPawn, generatedPawn);
//                generatedPawn.ageTracker.AgeBiologicalTicks = originalPawn.ageTracker.AgeBiologicalTicks;
//                generatedPawn.ageTracker.AgeChronologicalTicks = originalPawn.ageTracker.AgeChronologicalTicks;
//                //만약 아군이면
//                if (originalPawn.Faction == Faction.OfPlayer)
//                {
//                    //아이템 드랍 (originalPawn.equipment.DropAll~ )사용시 오류남
//                    originalPawn.DropAndForbidEverything();
//                    //관계 유지
//                    generatedPawn.relations = originalPawn.relations;
//                }
//                //원래 폰이 있던곳에 소환
//                GenSpawn.Spawn(generatedPawn, originalPawn.Position, originalPawn.Map, 0);
//            }
//            else
//            {
//                //폰카인드, 이름, 팩션등등이 정해진 민초의 정보
//                (var generatedPawn, var isWildPawn) = CreateReplacedPawn(originalPawn);
//                //해당 폰을 소환
//                GenSpawn.Spawn(generatedPawn, originalPawn.Position, originalPawn.Map, 0);
//                //정착민, 죄수일때 장비 유지
//                if (originalPawn.Faction == Faction.OfPlayer)
//                {
//                    originalPawn.DropAndForbidEverything();
//                    //의상 떨굼
//                    if (originalPawn.IsColonist || originalPawn.IsPrisoner)
//                    {
//                        originalPawn.apparel.DropAll(originalPawn.Position, true, true);
//                        originalPawn.equipment.DropAllEquipment(originalPawn.Position, true);
//                        originalPawn.DropAndForbidEverything();
//                    }
//                }
//                //bool, 만약에 야인 폰이면 팩션이 없음
//                if (isWildPawn)
//                    generatedPawn.SetFaction(null);
//                generatedPawn.def.defName.Equals(MinchoDefOf.Mincho_ThingDef);
//                // IDK why this exists.(모르므로 지움 20201008)
//                //if (generatedPawn.Spawned && !generatedPawn.Downed)
//                //    generatedPawn.jobs.StopAll(false);
//            }
//            //원래 폰 삭제(이게 위에 있으면 처리가 꼬이므로 주의)
//            originalPawn.Destroy(DestroyMode.Vanish);
//            // play sound here if you want to put sound when the pawn created.
//            SoundStarter.PlayOneShot(MinchoWitchDefOf.Pawn_Mincho_Death, SoundInfo.InMap(originalPawn, 0));
//        }

//        //피뿌림. 바닐라 코드 참조.
//        private static void CreateMinchoFilth(Pawn pawn)
//        {
//            for (int i = 0; i < 9; i++)
//            {
//                IntVec3 Pos = pawn.Position + GenRadial.RadialPattern[i];
//                bool canPlaceFilthToPos = GenGrid.InBounds(Pos, pawn.Map) && GridsUtility.GetRoom(pawn.Position, pawn.Map, (RegionType)6) == GridsUtility.GetRoom(Pos, pawn.Map, (RegionType)6);
//                if (canPlaceFilthToPos)
//                    FilthMaker.TryMakeFilth(pawn.Position, pawn.Map, MinchoWitchDefOf.Mincho_Filth_BloodDef, GenText.LabelIndefinite(pawn), Rand.RangeInclusive(0, 4));
//            }
//        }

//        private static (Pawn pawn, bool isWildMan) CreateReplacedPawn(in Pawn originalPawn)
//        {
//            bool isWildMan = false;
//            PawnGenerationRequest generationRequest = new PawnGenerationRequest(
//            MinchoWitchDefOf.Mincho_Colonist_Infection, Faction.OfPlayer,

//            (PawnGenerationContext)2, -1, false,
//            false, false, false, false, false, 0f, false, false, false, false, false, false,
//            false, false, 0, null, 0, null, null, null, null, null,

//            originalPawn.ageTracker.AgeBiologicalYearsFloat,
//            originalPawn.ageTracker.AgeChronologicalYearsFloat,

//            null, 0, "Temp", "Temp", null);

//            // set faction of pawn
//            if (originalPawn.Faction == Faction.OfPlayer || originalPawn.IsPrisonerOfColony)
//                generationRequest.Faction = Faction.OfPlayer;

//            else if (originalPawn.Faction.AllyOrNeutralTo(Faction.OfPlayer))
//                generationRequest.Faction = originalPawn.Faction;

//            //와일드맨 여부의 판단
//            else
//                isWildMan = true;

//            (var childhood, var adult, var faction, var kind) = GetBackstoryAndFaction(originalPawn);

//            // generate pawn and create 
//            var generatedPawn = PawnGenerator.GeneratePawn(generationRequest);
//            generatedPawn.story.childhood = childhood;
//            generatedPawn.story.adulthood = adult;
//            generatedPawn.kindDef = kind;
//            generatedPawn.SetFaction(faction, null);
//            // 관계가 이어짐 (20201112 확인)
//            TranslatePawnRelations(originalPawn, generatedPawn);
//            CopyName(originalPawn, generatedPawn);
//            generatedPawn.skills = originalPawn.skills ?? generatedPawn.skills; // move skills
//            if (originalPawn.RaceProps.Humanlike)
//            {
//                generatedPawn.story.traits.allTraits = originalPawn.story.traits.allTraits; // move traits
//                RemoveForbiddenTrait(ref generatedPawn);
//            }
//            else
//            {
//                RemoveForbiddenTrait(ref generatedPawn);
//            }
//            return (generatedPawn, isWildMan);
//        }

//        private static void TranslatePawnRelations(Pawn from, Pawn to)
//        {
//            RemoveRelationFromOtherRelatedPawns(from);
//            foreach (var relation in from.relations.DirectRelations)
//                to.relations.AddDirectRelation(relation.def, relation.otherPawn);
//        }

//        private static void CopyName(Pawn from, Pawn to)
//        {
//            var name = from.Name;
//            if (name is NameTriple triple)
//                to.Name = new NameTriple(triple.First, triple.Nick, triple.Last);
//            else if (name is NameSingle single)
//                to.Name = new NameSingle(single.Name, single.Numerical);
//        }

//        private static void RemoveRelationFromOtherRelatedPawns(Pawn pawn)
//        { // pawn과 관계가 있는 모든 폰에게서 pawn에 관한 관계를 삭제
//            var relatedPawns = pawn.relations.RelatedPawns;
//            foreach (var otherPawn in relatedPawns)
//            {
//                var relationsList = new List<DirectPawnRelation>(otherPawn.relations.DirectRelations);
//                foreach (var relation in relationsList.Where(r => r.otherPawn == pawn))
//                    otherPawn.relations.RemoveDirectRelation(relation);
//            }
//        }

//        private static void RemoveForbiddenTrait(ref Pawn pawn)
//        {
//            var traits = pawn.story.traits.allTraits;
//            traits.RemoveAll(trait => forbiddenStrings.Contains(trait.def.defName));
//        }

//        // 오리지널 폰의 팩션에 따른 따른 민초 백스토리와 팩션, pawnkind 설정
//        private static (Backstory childhood, Backstory adult, Faction faction, PawnKindDef kind) GetBackstoryAndFaction(in Pawn originalPawn)
//        {
//            Backstory childHoodBackstory = null;
//            Faction faction = null;
//            PawnKindDef kind = null;
//            string Identifier = string.Empty;
//            var pawnKindDefType = originalPawn.kindDef.defName;
//            // 인간 계열
//            if (originalPawn.RaceProps.Humanlike)
//            {
//                // 정착민
//                if (originalPawn.IsColonist)
//                {
//                    Identifier = "Mincho_Infection_Colonist";
//                    faction = Faction.OfPlayer;
//                    kind = MinchoWitchDefOf.Mincho_Colonist_Infection;
//                }
//                // 죄수
//                else if (originalPawn.IsPrisoner)
//                {
//                    Identifier = "Mincho_Infection_Prisoner";
//                    faction = Faction.OfPlayer;
//                    kind = MinchoWitchDefOf.Mincho_Colonist_Infection;
//                }
//                // 야인
//                else if (pawnKindDefType.Equals("WildMan"))
//                {
//                    Identifier = "Mincho_Infection_Wildman";
//                    faction = null;
//                    kind = PawnKindDefOf.WildMan;
//                }
//                // 중립우호
//                else if (originalPawn.Faction.AllyOrNeutralTo(Faction.OfPlayer))
//                {
//                    Identifier = "Mincho_Infection_NPC";
//                    faction = originalPawn.Faction;
//                    kind = MinchoWitchDefOf.Mincho_NPC_Infection;
//                }
//                // 적대
//                else if (originalPawn.Faction.HostileTo(Faction.OfPlayer))
//                {
//                    Identifier = "Mincho_Infection_Pirate";
//                    faction = null;
//                    kind = PawnKindDefOf.WildMan;
//                }
//            }
//            // 동물
//            else if (originalPawn.RaceProps.trainability == TrainabilityDefOf.Advanced)
//            {
//                // 아군동물
//                if (originalPawn.Faction == Faction.OfPlayer)
//                {
//                    Identifier = "Mincho_Infection_Animal_Colony";
//                    faction = Faction.OfPlayer;
//                    kind = MinchoWitchDefOf.Mincho_Colonist_Infection;
//                }
//                // 야생동물
//                else if (originalPawn.Faction == null)
//                {
//                    Identifier = "Mincho_Infection_Animal_Wild";
//                    faction = null;
//                    kind = PawnKindDefOf.WildMan;
//                }
//                // 적대동물
//                else if (originalPawn.Faction.HostileTo(Faction.OfPlayer))
//                {
//                    Identifier = "Mincho_Infection_Animal_Pirate";
//                    faction = null;
//                    kind = PawnKindDefOf.WildMan;
//                }
//                // 중립우호동물
//                else if (originalPawn.Faction.AllyOrNeutralTo(Faction.OfPlayer))
//                {
//                    Identifier = "Mincho_Infection_Animal_NPC";
//                    faction = originalPawn.Faction;
//                    kind = MinchoWitchDefOf.Mincho_NPC_Infection;
//                }
//            }
//            //나머지
//            else
//            {
//                Identifier = "Mincho_Infection_Undefined";
//                faction = originalPawn.Faction;
//                kind = PawnKindDefOf.WildMan;
//            }

//            childHoodBackstory = BackstoryDatabase.allBackstories[Identifier];

//            return (childHoodBackstory, null, faction, kind);
//        }
//    }
//}
