﻿using AlienRace;
using RimWorld;
using Verse;


namespace MinchoWitch
{
    [DefOf]
    public static class MinchoWitchDefOf
    {
        public static ThingDef_AlienRace MinchoWitch = new ThingDef_AlienRace();

        public static PawnKindDef Mincho_Colonist_Infection = new PawnKindDef();
        public static PawnKindDef Mincho_NPC_Infection = new PawnKindDef();
        public static PawnKindDef Mincho_Minmoong;
        public static PawnKindDef Mincho_Minchonyang;

        public static SoundDef Pawn_Mincho_Death = new SoundDef();
        public static HediffDef Mincho_Infection = new HediffDef();
        public static HediffDef Mincho_Infection_Instant = new HediffDef();
        public static HediffDef MinchoWitch_MinchoGolem_NoPain = new HediffDef();
        public static HediffDef MinchoWitch_Iced_Brain = new HediffDef();
        public static ThingDef Mincho_Filth_BloodDef = new ThingDef(); //나중에민초모드껄로
        public static GameConditionDef MinchoFallout;

        public static MentalBreakDef RunWild;
        static MinchoWitchDefOf()
        {
            DefOfHelper.EnsureInitializedInCtor(typeof(MinchoWitchDefOf));
        }
    }
}