﻿using Verse;

namespace ChangeRace
{
    public class HediffComp_ChangeRace : HediffComp
    {
        public HediffCompProperties_ChangeRace Props
        {
            get
            {
                return (HediffCompProperties_ChangeRace)props;
            }
        }

        public override void CompPostTick(ref float severityAdjustment)
        {
            foreach (ThingDef immunerace in Props.immuneRace)
            {
                if (Pawn.def == immunerace)
                {
                    HealthUtility.Cure(parent);
                    return;
                }
            }

            base.CompPostTick(ref severityAdjustment);
            if (parent.Severity >= Props.requiredSeverity)
            {

                TestErrorLog("@@@@@@@@@@@@ Try Change Race @@@@@@@@@@@");
                //종족변환 실행
                Props.changeRaceLogicDef.ChangeRaceLogic(Pawn, parent);

                TestErrorLog("Heal " + parent.def.defName);
                HealthUtility.Cure(parent);

            }
        }

        private void TestErrorLog(params string[] arr1)
        {
            if (ChangeRace_Setting.ChangeRaceTestLog)
            {
                for (int i = 0; i < arr1.Length; i++)
                {
                    Log.Error(arr1[i]);
                }
            }
        }
    }
}