﻿using HarmonyLib;
using System;
using Verse;

//Original code by FP
namespace MinchoWitch
{
    [StaticConstructorOnStartup]
    public static class Harmony_MinchoGolem
    {
        static Harmony_MinchoGolem()
        {
            Harmony harmonyInstance = new Harmony("Marilyn_the_Mincho_Worshipper_Witch");
            harmonyInstance.Patch(AccessTools.Method(typeof(PawnGenerator), "GenerateInitialHediffs", null, null), null, new HarmonyMethod(patchType, "GenerateInitialHediffsPostFix", null), null, null);
            Log.Message("Marilyn_the_Mincho_Worshipper_Witch");
        }

        [HarmonyPostfix]
        public static void GenerateInitialHediffsPostFix(Pawn pawn, PawnGenerationRequest request)
        {
            bool flag = pawn.def.defName == "MinchoWitch_MinchoGolem";
            if (flag)
            {
                Hediff hediff = HediffMaker.MakeHediff(MinchoWitchDefOf.MinchoWitch_MinchoGolem_NoPain, pawn, null);
                hediff.Severity = 0.1f;
                pawn.health.AddHediff(hediff, null, null, null);
            }
        }

        private static readonly Type patchType = typeof(Harmony_MinchoGolem);
    }
}
